/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package mipsopcodes;

/**
 *
 * @author Nshidbaby
 */

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.BorderFactory;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JMenuBar;

import java.io.PrintStream;

public class OpGUI extends JFrame implements ActionListener
{
    private JButton    clearButton;
    private JButton    findButton;
    private JTextField opcodeTextField;
    private JTextField bin1TextField;
    private JTextField bin2TextField;
    private JTextField bin3TextField;
    private JTextField bin4TextField;
    private JTextField instrTextField;
    private JTextArea  instrtextArea;
    private JTextArea  abouttextArea;
    private JFrame     aboutFrame;
    private JLabel     binLabel;
    private JLabel     opcodeLabel;
    private JMenu      file;
    private JMenu      help;
    private JMenuItem  item1;
    private JMenuItem  item2;
    private JMenuItem  item3;
    private JMenuBar   menuBar;

    private JPanel     inframewin1;
    private JPanel     inframewin2;

    private int        exceptioncheck;



    public OpGUI()
    {
        super("MIPsFinder - MIPS Instruction Finder (*beta)" );

        this.setSize(600, 350);
        this.setLayout( new GridLayout(5,1));
        this.setLocationRelativeTo(null);
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        inframewin1 = new JPanel();
        inframewin1.setSize(600, 150);
    
        inframewin2 = new JPanel();
        inframewin2.setSize(600, 150);

        file = new JMenu("File");

        help = new JMenu("Help");

        item1 = new  JMenuItem("Reset All Fields");
        item1.addActionListener(this);

        item2 = new  JMenuItem("Clear Binary Fields");
        item2.addActionListener(this);

        item3 = new JMenuItem("About MIPsFinder");
        item3.addActionListener(this);

        file.add(item1);
        file.add(item2);

        help.add(item3);

        menuBar = new JMenuBar();

        menuBar.add(file);
        menuBar.add(help);

        this.setJMenuBar(menuBar);

        aboutFrame = new JFrame("About MIPsFinder");
        aboutFrame.setSize(300, 285);
        
        aboutFrame.setLocationRelativeTo(this);

        abouttextArea = new JTextArea(300, 285);
        abouttextArea.setBackground(Color.lightGray);
        abouttextArea.setEditable(false);
        
        abouttextArea.append("\n   MIPsFinder\n   -===----===-\n\n   Version: *Beta" +
                "\n   April 14, 2010\n\n" +
                "   Developed by: Nshidbaby!\n\n   ***MIPsFinder is a reference " +
                "program which\n        allows a user to find a MIPS instruction " +
                "from\n        a corresponding 32-bit binary number.\n\n\n   " +
                "2010 Nashid Shabazz\n");

        aboutFrame.add(abouttextArea);

        instrtextArea = new JTextArea(600, 350);
  
        instrtextArea.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
        instrtextArea.setBorder((BorderFactory.createLineBorder(Color.black)));
        
        instrtextArea.setEditable(false);

        instrTextField = new JTextField(19);

        instrTextField.add(instrtextArea);

        instrtextArea.setRows(1);

        binLabel = new JLabel("32-bit Binary Number");
        inframewin1.add(binLabel);

        bin1TextField = new JTextField(8);
        inframewin1.add(bin1TextField);

        bin2TextField = new JTextField(8);
        inframewin1.add(bin2TextField);

        bin3TextField = new JTextField(8);
        inframewin1.add(bin3TextField);

        bin4TextField = new JTextField(8);
        inframewin1.add(bin4TextField);

        opcodeLabel = new JLabel("Opcode Type");
        inframewin2.add(opcodeLabel);

        opcodeTextField = new JTextField(24);
        opcodeTextField.setBackground(Color.white);
        opcodeTextField.setEditable(false);
        inframewin2.add(opcodeTextField);

    //Code borrowed and modified from buddybob:
    //http://www.jcreator.com/forums/lofiversion/index.php?t773.html

    // ------------------Borrowed code (below) begins here------------------
    // Now create a new TextAreaOutputStream to write to our JTextArea
    // control and wrap a PrintStream around it to support the
    // println/printf methods.
    PrintStream out = new PrintStream(new TextAreaOutputStream(instrtextArea));
//
//    // redirect standard output stream to the TextAreaOutputStream
    System.setOut( out );
//
//    // redirect standard error stream to the TextAreaOutputStream
    System.setErr( out );

    // -------------------Borrowed code (above) ends here-------------------

        this.add(inframewin1);
        this.add(inframewin2);
        this.add(instrtextArea);

        clearButton = new JButton("Clear Binary Fields");
        clearButton.addActionListener(this);
        this.add(clearButton);

        findButton = new JButton("Find It!");
        findButton.addActionListener(this);
        this.add(findButton);


        inframewin1.setVisible(true);
        inframewin2.setVisible(true);
        this.setVisible(true);
    }


    public void actionPerformed(ActionEvent e)
    {
        try
        {
            if( e.getActionCommand().equals("About MIPsFinder") )
            {
                aboutFrame.setVisible(true);
            } else if( e.getActionCommand().equals("Reset All Fields") )
            {
                bin1TextField.setText("");
                bin2TextField.setText("");
                bin3TextField.setText("");
                bin4TextField.setText("");
                instrtextArea.setText("");
                opcodeTextField.setText("");
            }
            else if( e.getActionCommand().equals("Clear Binary Fields") )
            {
                bin1TextField.setText("");
                bin2TextField.setText("");
                bin3TextField.setText("");
                bin4TextField.setText("");
            }
            else if( e.getActionCommand().equals("Find It!") )
            {
                int i;
                opcodeTextField.setText("");
                instrtextArea.setText("");
                String binarynum = null;
                String bin1 = bin1TextField.getText();
                String bin2 = bin2TextField.getText();
                String bin3 = bin3TextField.getText();
                String bin4 = bin4TextField.getText();
          
                if (bin1.equals("") || (bin1.length()!= 8)){
                  exceptioncheck = 1;
                  throw new Exception(" Enter 8-bit #!");
                } 
                for(i=0; i<8; i++){
                    if ((bin1.charAt(i) == '1') || (bin1.charAt(i) == '0')){
                        continue;
                    } else {
                        exceptioncheck = 1;
                        throw new Exception("Enter 0s or 1s!");
                    }
                }
                if (bin2.equals("") || (bin2.length()!= 8)){
                    exceptioncheck = 2;
                    throw new Exception(" Enter 8-bit #!");
                }
                for(i=0; i<8; i++){
                    if ((bin2.charAt(i) == '1') || (bin2.charAt(i) == '0')){
                        continue;
                    } else {
                        exceptioncheck = 2;
                        throw new Exception("Enter 0s or 1s!");
                    }
                }
                if (bin3.equals("") || (bin3.length()!= 8)){
                    exceptioncheck = 3;
                    throw new Exception(" Enter 8-bit #!");
                }
                for(i=0; i<8; i++){
                    if ((bin3.charAt(i) == '1') || (bin3.charAt(i) == '0')){
                        continue;
                    } else {
                        exceptioncheck = 3;
                        throw new Exception("Enter 0s or 1s!");
                    }
                }
                if (bin4.equals("") || (bin4.length()!= 8)){
                    exceptioncheck = 4;
                    throw new Exception(" Enter 8-bit #!");
                }           
                for(i=0; i<8; i++){
                    if ((bin4.charAt(i) == '1') || (bin4.charAt(i) == '0')){
                        continue;
                    } else {
                        exceptioncheck = 4;
                        throw new Exception("Enter 0s or 1s!");
                    }
                }

                binarynum = bin1 + bin2 + bin3 + bin4;
                
                if(binarynum.length()!= 32)
                {
                    exceptioncheck = 5;
                    throw new Exception("\n\t\tPlease enter a 32-bit binary number!");
                } else
                {
                    opcodeTextField.setText("\t");
                    Opcodes myopcode = new Opcodes(binarynum);

                    if (myopcode.getOpcode().equals("rtype")){
                        opcodeTextField.setText("\tR-Type");
                        instrtextArea.setText("\n\t\t                        ");
                        Rtype newval = new Rtype(myopcode.getParameters());
                        newval.getInstruction();
                    } else if (myopcode.getOpcode().equals("jtype")){
                        opcodeTextField.setText("\tJ-Type");
                        instrtextArea.setText("\n\t\t                               ");
                        Jtype myval = new Jtype(myopcode.getOpcodeNum(),myopcode.getParameters());
                        myval.getInstruction();
                    } else if (myopcode.getOpcode().equals("itype")){
                        opcodeTextField.setText("\tI-Type");
                        instrtextArea.setText("\n\t\t                    ");
                        Itype ourval = new Itype(myopcode.getOpcodeNum(),myopcode.getParameters());
                        ourval.getInstruction();
                    }
                }
            }
        }
        catch(Exception exp)
        {
            if (exceptioncheck == 1){
            bin1TextField.setText(exp.getMessage());
            } else if (exceptioncheck == 2){
            bin2TextField.setText(exp.getMessage());
            } else if (exceptioncheck == 3){
            bin3TextField.setText(exp.getMessage());
            } else if (exceptioncheck == 4){
            bin4TextField.setText(exp.getMessage());
            } else if (exceptioncheck == 5){
            instrtextArea.setText(exp.getMessage());
            }
         }
        }
}